//        Copyright  1999-2001 QUALCOMM Incorporated.
//               All Rights Reserved.
//            QUALCOMM Proprietary/GTDR
#ifndef _appclasses_h_
#define _appclasses_h_

#include "AEEDisp.h"
#include "AEEShell.h"

// Size of buffer used to hold text strings
#define TEXT_BUFFER_SIZE (120 * sizeof(AECHAR))

//--------------------------------------------------------------------------
// Writer class declaration
//--------------------------------------------------------------------------
class Writer
{
public:
    Writer(IShell* pIShell);                    // Constructor
    virtual     ~Writer();                      // Destructor
    virtual     void WriteLine(char *pszStr);   // Base Class WriteLine
    void        operator << (char *pszStr);     // Stream out operator
    void*       operator new(unsigned int size);// new operator
    void        operator delete(void * ptr);    // delete operator

protected:
    int         DisplayOutput(int nline, char *pszStr); // overloaded display o/p
    int         DisplayOutput(IStatic* sc, char *pszStr); // overloaded display o/p

private:
    Writer();                       // Default constructor
    IDisplay*       m_pIDisplay;    // display instance
    int             m_cLineNum;     // screen line to be written to next
    int             m_cMaxLine;     // max line number of screen on which output can be written
    AEEDeviceInfo   m_di;           // device info
};

//--------------------------------------------------------------------------
// SmartWriter class declaration
//--------------------------------------------------------------------------
class SmartWriter : public Writer
{
public:
    SmartWriter(IShell* pIShell);               // Constructor
    virtual     ~SmartWriter();                 // Destructor
    virtual     void WriteLine(char *pszStr);   // Derived Class WriteLine 
    void        operator << (char *pszStr);     // Stream out operator 
    void*       operator new(unsigned int size);// new operator
    void        operator delete(void * ptr);    // delete operator

private:
    SmartWriter();
    IStatic*        m_pIText;
};
#endif