//        Copyright  1999-2001 QUALCOMM Incorporated.
//               All Rights Reserved.
//            QUALCOMM Proprietary/GTDR
#if !defined(_I411VIEWER_H_)
#define _I411VIEWER_H_

#include "AEEAppGen.h"	// AEEApplet Declaration

// App resource header generated by BREW ResourceEditor.
#include "AEE.h"			// Standard AEE Declarations
#include "AEEShell.h"	// AEE Shell Services
#include "AEEDisp.h"		// AEE Display Services
#include "AEEHeap.h"		// AEE Memory Allocation Services
#include "AEEStdLib.h"  // AEE StdLib Services

// App developer code BEGIN
//
// Services used by app
#include "AEEFile.h"		   //	AEE File Services
#include "AEEGraphics.h"   // AEE IGraphics Services
#include "AEEImage.h"   // AEE AEEImage Services
#include "AEETime.h"       // AEE Time Services
#include "AEEDate.h"       // AEE Date Services
#include "aeetext.h"       // AEE Text Services


typedef struct _CI411Image		CI411Image;

struct _CI411Image
{
	DECLARE_VTBL(IImage)

	IDisplay *				m_pDisplay; // Display
	IShell *				m_pShell;   // Shell
	AEEImageInfo			m_info;     // generic info

	// Notify stuff
	PFNIMAGEINFO			m_pfnNotify; // Notify callback
	void *					m_pUser;	// User data

	// SetStream stuff
	IAStream *				m_pStream;	// Data Stream
	int32					m_nBytes;	// Num Bytes
	int32					m_nRead;	// Bytes Read

	uint32					m_cls;      // our class
	int32					m_nRefs;    // reference count
	AEERect					m_rc;       // destination x,y,cx,cy
	int16					m_xOffset;  // x offset into image
	int16					m_yOffset;  // y offset into image
	AEERasterOp				m_rop;      // raster op
	void *					m_pData;    // raw data
	void *					m_pBmp;     // bitmap data
	void *					m_pvt;		// Vtable for freeing

	int16					m_nFrame;   // current frame
	int16					m_nFrames;  // number of frames
	int16					m_nRate;

};

#endif //_I411VIEWER_H_
