#ifndef NOTIFIER_H
#define NOTIFIER_H
/*======================================================
FILE:  notifier.h

SERVICES:  notifier include file.

GENERAL DESCRIPTION:
	This file contians the notifier class definitions.

        Copyright  2000-2001 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/
/*===============================================================================
                     INCLUDES AND VARIABLE DEFINITIONS
=============================================================================== */
#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEShell.h"
#include "AEEDisp.h"
#include "AEEModTable.h"
#include "AEEStdLib.h"
#include "AEEControls_res.h"
#include "AEEUsageAppIDs.h"

/*===========================================================================

                      PUBLIC DATA DECLARATIONS

===========================================================================*/
// Notifier class strucutre. 
typedef struct _NotifierClass
{
   // vtable
   DECLARE_VTBL(INotifier)  
   AEEModObj *    pNext;
   AEECLSID       clsID;// ClassID of notifier class

	// data members
   uint32       m_nRefs;        // Class reference counter
   IShell    *  m_pIShell;      // pointer to IShell
   IModule   *  m_pIModule;     // pointer to IModule
   IDisplay  *  m_pIDisplay;    // pointer to IDisplay

   uint32       m_dwNotifyMask; // Used in timer callback function.
}NotifierClass;

// Notifier function prototypes
uint32  NotifierClass_AddRef(INotifier* po);
uint32  NotifierClass_Release(INotifier* po);
void    NotifierClass_SetMask(INotifier* po, const uint32 * dwMask);
void    NotifierClass_TimerCB (void *pi);
boolean NotifierClass_New(int16 nSize, AEECLSID clsID, IShell * pIShell, IModule * pIModule, NotifierClass **ppobj);

/*-------------------------------------------------------------------
            Type Declarations
-------------------------------------------------------------------*/

/*-------------------------------------------------------------------
            Function Prototypes
-------------------------------------------------------------------*/
void DisplayOutput(IShell *pIShell, IDisplay *pDisplay, int nline, char *pszStr);

/*-------------------------------------------------------------------
            Global Constant Definitions
-------------------------------------------------------------------*/
#define NOTIFY_MASK_EVENT          0x00000001    // Dummy event mask for 
                                                 // notifier class 
/*-------------------------------------------------------------------
            Global Data Definitions
-------------------------------------------------------------------*/


/*-------------------------------------------------------------------
            Static variable Definitions
-------------------------------------------------------------------*/



#endif // 